//////////////////////////////
// Engine Includes
//////////////////////////////

#include <acknex.h>
#include <default.c>
#include <windows.h>

//////////////////////////////

var texturen_geladen=0;
var meshes_geladen=0;
//////////////////////////////
// Temporary String Objects
//////////////////////////////

STRING* temp_str="";
STRING* temp_str2="";

//////////////////////////////


BMAP* mouse_bmap="#16x16x16";

BMAP* popup1_bmap="#186x28x16";
BMAP* popup1on_bmap="#186x28x16";

BMAP* dialogbutton1_bmap="#428x22x16";
BMAP* dialogbutton1on_bmap="#428x22x16";

BMAP* facestexture="#64x64x16";

BMAP* texture1="#64x64x16";



BMAP* mousebmap;

//////////////////////////////
// Font Objects
//////////////////////////////

FONT* font1 = "Fixedsys#25b";
FONT* font2 = "Lucida Console#20";
FONT* font3 = "WST_Engl#10";
FONT* font4 = "Lucida Console#15";
FONT* font5 = "Lucida Console#12b";
FONT* font6 = "Lucida Console#20b";
FONT* font7 = "Lucida Console#40b";

//////////////////////////////


//////////////////////////////
// Global Objects
//////////////////////////////

var object_in_mouse=0;

//Gesprche
int gespraech_max1=0;
int gespraech_lara1=0;
int gespraech_gordon1=0;


//Doors
var doorselect=0;
STRING* door_name[100];
ENTITY* doorp[100];


ENTITY* held;

int popupper;
//Spieler
var spieler_freiheit=0;
//Inventar
VIEW* invtr[21];
var invtr_object_anzahl[21];
ENTITY* invtr_object[21];
ENTITY* invtr_object_mesh[21];
STRING* invtr_objectname[21];
STRING* invtr_objectdesc[21];
var invtr_objectanzahl[21];

//Item
var item_in_inventar_anzahl=0;
var item_in_inventar=0;
var item_in_inventar_id=0;
var items=0;
ENTITY* itemp[100];
STRING* item_filename[100];
STRING* item_name[100];
STRING* item_desc[100];
var itemselect=0;
//Npc
var npc_anzahl;
STRING* npc_name[100];
STRING* npc_desc[100];
ENTITY* npcp[100];
ENTITY* npc_popupent;
var npc_popupent_id=0;



//Dialog
var thommyinfo=0;
var larasartefakt=0;
var maxpillen=0;
var dialoge4=0;
STRING* dialog_option1 = "";
STRING* dialog_option2 = "";
STRING* dialog_option3 = "";
STRING* dialog_option4 = "";
STRING* dialog_option1ausgabe="";
STRING* dialog_option2ausgabe="";
STRING* dialog_option3ausgabe="";
STRING* dialog_option4ausgabe="";
STRING* dialoge[200];
var dialog_button_angeklickt=0;
var dialog_ausgang=0;
var dialog_optionen_result=0;
var dialog_button_ready=0;
var dialog_linkung1=0;
var dialog_linkung2=0;
var dialog_linkung3=0;
var dialog_linkung4=0;
var tuer_id=0;
var tuer_zuoderauf=0;
var tuer_id1=0;
var tuer_zuoderauf1=0;
var tuer_id2=0;
var tuer_zuoderauf2=0;
var tuer_id3=0;
var tuer_zuoderauf3=0;
var tuer_id4=0;
var tuer_zuoderauf4=0;
var pfadid=0;	
var nodeid=0;
var nodewalktoid=0;
var dialogid=0;
var npcstatus=0;

//Pfad
var nodes_visible=0;
var nodes;
var nodesinpfad[100];
var pfadtyp[100];//0=Normal 1=Rundlauf
ENTITY* nodep[100][100];

//Schalter
ENTITY* schalterp[100];
var dialoge1=0;
var dialoge2=0;
var dialoge3=0;
ENTITY* kamera_hilfe={
	x=camera.x;
	y=camera.y;
	z=camera.z;
}

ENTITY* skyent;
//////////////////////////////
#define id skill2
#define status skill3
#define nodephase skill6
#define path skill12
#define next_node skill13
#define ziel_node skill14
#define counter skill98
#define dialog_num skill90

#define key_talk key_space
//////////////////////////////

//Hilfsfunktionen
function ent_look_at(ENTITY* ent, VECTOR* vec)
{
    VECTOR temp;
    var ent_tilt=ent.tilt;
    var ent_roll=ent.roll;
    vec_set(temp,vec.x);    
    vec_sub(temp,ent.x);
    vec_to_angle(ent.pan,temp);
    ent.tilt=ent_tilt;
    ent.roll=ent_roll;
}

function camera_topview()
{
	if(camera.z<1000)
	{
		spieler_freiheit=0;
		vec_set(camera.x,vector(724,-8500,32000));
		camera.pan = 90;
		camera.tilt = -80;
		return;
	}
	if(camera.z>1000)
	{
		spieler_freiheit=1;
		return;
	}
}
function npc_port_to(int npcid,int dpfad,int dnode)
{
	if(dpfad!=0 && dnode!=0)
	{
		npcp[npcid].path = dpfad;
		npcp[npcid].next_node = dnode;
		npcp[npcid].ziel_node = dnode;
		npcp[npcid].nodephase=1;
		npcp[npcid].skill99=0;
		vec_set(npcp[npcid].x,nodep[dpfad][dnode].x);
		npcp[npcid].z+=80;
		return;
	}
}
function npc_go_to(int npcid,int dpfad,int dnode)
{
	if(dpfad!=0 && dnode!=0)
	{
		npcp[npcid].path = dpfad;
		if(vec_dist(nodep[dpfad][1].x,npcp[npcid].x)<vec_dist(nodep[dpfad][nodesinpfad[dpfad]].x,npcp[npcid].x))
		{
			npcp[npcid].next_node = 1;
		}
		if(vec_dist(nodep[dpfad][1].x,npcp[npcid].x)>vec_dist(nodep[dpfad][nodesinpfad[dpfad]].x,npcp[npcid].x))
		{
			npcp[npcid].next_node = (nodesinpfad[dpfad]);
		}
		npcp[npcid].ziel_node = dnode; 
		npcp[npcid].nodephase=1;
		npcp[npcid].skill99=0;
		return;
	}
}

function npc_go_tonode(int npcid,int dnode)
{
	if(dnode!=0)
	{
		npcp[npcid].ziel_node = dnode; 
		npcp[npcid].nodephase=1;
		npcp[npcid].skill99=0;
		return;
	}
}

function lock_unlock_door(int doorid,int aufoderzu)
{
	if(doorid!=0 && aufoderzu<2)
	{
		doorp[doorid].skill5 = aufoderzu;
	}
}

function close_open_door(int doorid,int aufoderzu)
{
	if(doorid!=0 && (aufoderzu==1 || aufoderzu==2))
	{
		doorp[doorid].skill4 = aufoderzu;
	}
}
function toogle_mouse_mode()
{
	if(spieler_freiheit==1)
	{
		if(mouse_mode==1)
		{
			mouse_mode=2;
			return;
		}
		if(mouse_mode==2)
		{
			mouse_pos.x=-5; mouse_pos.y=-5;
			mouse_mode=1;
			return;
		}
	}
}
function nach_doctor()
{
	if(dialoge2==3)
	{
		lock_unlock_door(5,0);
		npc_port_to(1,3,3);
		npcp[5].status=5;
		wait(1);
		npc_port_to(2,17,5);	
		npcp[2].status=5;
		wait(1);
		npc_port_to(3,5,4);	
		npcp[3].status=5;
		wait(1);	
		npc_port_to(4,4,3);
		npcp[4].status=5;
		wait(1);
		npc_port_to(5,1,2);
		npcp[5].status=5;
		wait(1);	
		npc_port_to(6,16,3);
		npcp[6].status=5;
		wait(1);		
		npc_port_to(6,16,3);
		npcp[6].status=5;
		wait(1);		
		npc_port_to(7,3,5);
		npcp[7].status=5;
		wait(1);	
		
		//garten mann	
		npc_port_to(11,11,10);
		wait(1);	
		//hausmeister mann	
		npc_port_to(23,1,10);
		wait(1);					
		return;
	}
}


//////////////////////////////
// Other Script Includes
//////////////////////////////
var test=0;
var testx=0;
var testy=0;
var testz=0;
STRING* test_str="";
var incutscene=0;




#include "Scripts\\Messaging.c"

#include "Scripts\\Items.c"
#include "Scripts\\Invtr.c"
#include "Scripts\\Dialog.c"
#include "Scripts\\Npcs.c"


#include "Scripts\\Sky.c"
#include "Scripts\\Player.c"
#include "Scripts\\schalter.c"
#include "Scripts\\Doors.c"
#include "Scripts\\Pathfinding.c"
#include "Scripts\\World.c"


#include "Scripts\\Meshes1.c"
#include "Scripts\\Meshes2.c"
#include "Scripts\\Meshes3.c"
#include "Scripts\\Meshes4.c"
#include "Scripts\\Meshes5.c"
#include "Scripts\\Meshes.c"
#include "Scripts\\Bitmaps.c"
#include "Scripts\\save_load.c"
//Main-Menu
PANEL* main_menu=
{
	digits(0,0,"TheCamp - Contest Version - English\n\n\n(N)ew Game\n\n[(L)oad Game] Sorry not aviable :-(\n\n(H)elp\n\n\n(C)redits\n(E)xit\n\n\n\nV. 0.64",font2,1,0);

	pos_x = 580;
	pos_y = 46;
	layer = 200;
}
TEXT* bis_bald=
{
	font = font7;
	string="Bis bald!";
}
STRING* contest_str="
      _________________________________________________________
     /                                                        /    
    /               Winter 2008 Contest                      /
   /                                                        /       
  /     'No external files' Lite-C contest entry           /
 /                              Daniel 'CetiLiteC' Otto   /
/________________________________________________________/


6th April - 15th April 2009 ATTENTION: we didn't want to send in this game 
in this development state. But we did. There are so many bugs in it. 
Play this game as a \"buggy demo\". In near future we will release the 
full, bug-free version. Without external files, still!
After ca. two weeks of fulltime development the game ended in a totally
chaos in the night of the 15th April. 
                                     We are really sorry for this desaster.
                                                     CetiLiteC&Creon
                                                           
                                                          
";
TEXT* contest_txt=
{
	string = contest_str;

	pos_x = 577;
	pos_y = 457;		
}

//////////////////////////////


var in_game=0;
function new_game()
{
	wait(64);	
	spieler_freiheit=0;
	reset(contest_txt,VISIBLE);
	camera.pan = 180;		
	vec_set(camera.x,vector(-10153,-13828,371));
	vec_set(held.x,camera.x);
	mouse_mode=1;
	clear_messages();
	wait(-2);
	message("*Du wirst von lautem Krach geweckt*");
	wait(-1);

	set(camera,TRANSLUCENT | VISIBLE);
	camera.alpha=0;

	npcp[13].status=1;
	while(camera.alpha<99)
	{
		camera.alpha+=5*time_step;
		wait(1);
	}

	int cutscene1_zuende=0;


	while(npcp[13].status<10)
	{
		if(npcp[13].status<3)
		{
			camera.tilt += mouse_force.y*10*time_step;
			camera.pan -= mouse_force.x*10*time_step;
			if(camera.tilt<-50){camera.tilt=-50;}
			if(camera.tilt>60){camera.tilt=60;}
			if(camera.pan<90){camera.pan=90;}
			if(camera.pan>145){camera.pan=145;}
		}
		if(npcp[13].status==4)
		{
			vec_set(camera.pan,kamera_hilfe.pan);
			vec_set(kamera_hilfe.x,camera.x);
		}
		if(npcp[13].status==6)
		{
			npc_go_tonode(13,1);
			wait(1);
			wait(-2);
			npc_go_to(13,7,1);
			wait(1);
			vec_set(held.x,vector(-9569,-14645,500));
			camera.tilt=0;
			held.pan = 180;
			camera.roll=0;
			spieler_freiheit=1;
			npcp[13].status=7;
			wait(-2);
			close_open_door(3,2);
			lock_unlock_door(3,1);
			in_game=1;
			held.status=1;
			return;
		}
		wait(1);
	}
}
var in_menu=0;
var spieler_freiheit_vorher=0;
var mouse_mode_vorher=0;
function neu()
{
	reset(camera,VISIBLE);
	in_menu=0;
	on_n=NULL;
	on_l=NULL;
	on_s=NULL;
	on_c=NULL;
	on_e=NULL;
	reset(main_menu,VISIBLE);
	set(messages_pan,VISIBLE);
	set(contest_txt,VISIBLE);

	new_game();
}
function laden()
{
	load();
}
function speichern()
{
	if(in_game==1)
	{
		save();
	}
}
function clear_dir()
{
	var fhdl = file_open_write("kill_temp.bat");
/*	file_str_write(fhdl,
"@echo off
del *.x 
del *.png */
file_str_write(fhdl,
"@echo off
del Camp.x
del Npc1.x
del Npc2.x
del Npc3.x
del Npc6.x
del Npc7.x
del npc8.x
del npc9.x
del Npc12.x
del Npc4.x
del Npc5.x
del itm11.x
del npc10.x
del npc11.x
del npc13.x
del null.x
del npc10.x
del held.x
del itm1.x
del itm2.x
del itm3.x
del itm4.x
del itm5.x
del itm6.x
del itm7.x
del itm8.x
del Door1.x
del Door2.x
del Door3.x
del Door4.x
del Door5.x
del Door6.x
del cube.x

del itmbb.x

del dialogbutton1_bmap.png
del mouse_bmap.png
del popup1_bmap.png
del popup1on_bmap.png
del sky.png
del texture1.png
del npcs.png

del dialog.tempf

del ackerr.txt
del acklog.txt 
del OUIETERR.TXT
del kill_temp.bat
");
	file_close(fhdl);
exec("kill_temp.bat","");	
}
function beenden()
{
	clear_dir();
	
	sys_exit("");
}
#include "Scripts\\Credits.c"
function credits()
{
	credit_loop();
}
function menu_visiblity()
{
	if(in_menu==0)
	{
	//	vec_set(camera.x,vector(724,-8500,32000));
	//	camera.pan = 90;
	//	camera.tilt = -80;
		spieler_freiheit_vorher=spieler_freiheit;
		mouse_mode_vorher=mouse_mode;		
		spieler_freiheit=0;
		mouse_mode=2;
		on_n=neu;
		on_l=laden;
		on_s=speichern;
		on_c=credits;
		on_e=beenden;		
		set(main_menu,VISIBLE);
		set(contest_txt,VISIBLE);
		reset(messages_pan,VISIBLE);
		in_menu=1;
		return;
	}
	if(in_menu==1)
	{
		on_n=NULL;
		on_l=NULL;
		on_s=NULL;
		on_c=NULL;
		on_e=NULL;
		reset(main_menu,VISIBLE);
		reset(contest_txt,VISIBLE);
		set(messages_pan,VISIBLE);
		spieler_freiheit=spieler_freiheit_vorher;
		mouse_mode=mouse_mode_vorher;			
		in_menu=0;
		return;
	}	
}

//////////////////////////////
// Main Function
//////////////////////////////
function main()
{	
	
//	Our Resolution: 800x600 pixel, 32 bit color. Absolutly okay for the project!
	//video_set(800,600,32,2);
	video_mode = 8;
	video_screen = 2;
	wait(10);
//	Set the Fps-Rate down to 150fps! This is needed for the speed performance of the messaging system.
	fps_max = 150;
	
	load_textures_and_bitmaps();
	while(texturen_geladen==0)
	{
		wait(1);
	}
	
	wait(20);
	load_meshes();
	while(meshes_geladen==0)
	{
		wait(1);
	}
	wait(20);	
//	We want to place the window in the centre of the screen, and we want to have a nice window title.
//	video_window(vector((sys_metrics(0)-1024)*0.5,(sys_metrics(1)-768)*0.5,0),vector(1024,768,0),112,"TheCamp - Contest Version - English");
//	Now loading all the needed Bitmaps 	
	wait(12);
	
// Now load the Npcs
	load_npcs();
	wait(12);
	
// Now load the Items
	load_items();
	wait(12);
	
// Now load the Doors
	load_doors();
	wait(12);	


	
// Now load the Dialogues
	load_dialoge();
	wait(12);


// Load the Camp
	load_world();
	wait(64);
//	reset(camera,VISIBLE);

	vec_set(camera.x,vector(724,-8500,32000));
	camera.pan = 90;
	camera.tilt = -80;
// Now load the Inventory Views	
	load_invtr();
	wait(12);
		
//	Set the Mouse
	mouse_map = mousebmap;
	mouse_mode = 2;

//	Place the 3D-View on the Screen
	camera.pos_x = 32;
	camera.pos_y = 32;
	
//	Rescale the 3D-View
	camera.size_x = 512;
	camera.size_y = 512;
	
	sun_light=10;

	
	on_f1 = nodes_visiblity;
	on_f2 = camera_topview;
	
	message("Acknex 7 loaded!");
	message("Now loading The Camp!");
//	wait(-3);
	in_menu=1;
	on_n=neu;
	on_l=laden;
	on_s=speichern;
	on_c=credits;
	on_e=beenden;	

	set(main_menu,VISIBLE);
	set(contest_txt,VISIBLE);
	on_q = toogle_mouse_mode;
	on_esc=menu_visiblity;
	while(1)
	{
		if(mouse_mode==2)
		{
			mouse_pos.x = mouse_cursor.x;    mouse_pos.y = mouse_cursor.y;
			mouse_map = mousebmap;
		}
		if(mouse_mode==1)
		{
			mouse_pos.x=-5; mouse_pos.y=-5;
			mouse_map = NULL;
		}
		//3D-Ansicht-Kasten
		draw_line(vector(31,31,0),NULL,0);
		draw_line(vector(31,31,0),vector(128,128,128),100);
		draw_line(vector(543,31,0),vector(128,128,128),100);
		draw_line(vector(543,543,0),vector(128,128,128),100);
		draw_line(vector(31,543,0),vector(128,128,128),100);
		draw_line(vector(31,31,0),vector(128,128,128),100);
		draw_line(vector(31,31,0),NULL,0);
		
		//Orts-Kasten
		draw_line(vector(48,558,0),NULL,0);
		draw_line(vector(48,558,0),vector(128,128,128),100);
		draw_line(vector(378,558,0),vector(128,128,128),100);
		draw_line(vector(378,575,0),vector(128,128,128),100);
		draw_line(vector(48,575,0),vector(128,128,128),100);
		draw_line(vector(48,558,0),vector(128,128,128),100);
		draw_line(vector(48,558,0),NULL,0);
		
		//Messages-Kasten
		draw_line(vector(568,30,0),NULL,0);
		draw_line(vector(568,30,0),vector(128,128,128),100);
		draw_line(vector(1000,30,0),vector(128,128,128),100);
		draw_line(vector(1000,540,0),vector(128,128,128),100);
		draw_line(vector(568,540,0),vector(128,128,128),100);
		draw_line(vector(568,30,0),vector(128,128,128),100);
		draw_line(vector(568,30,0),NULL,0);
		
		//Dialog
		draw_line(vector(568,450,0),NULL,0);
		draw_line(vector(568,450,0),vector(128,128,128),100);
		draw_line(vector(1000,450,0),vector(128,128,128),100);
		draw_line(vector(1000,450,0),NULL,0);
		
		//Inventar-Kasten
		draw_line(vector(40,595,0),NULL,0);
		draw_line(vector(40,595,0),vector(128,128,128),100);
		draw_line(vector(860,595,0),vector(128,128,128),100);
		draw_line(vector(860,759,0),vector(128,128,128),100);
		draw_line(vector(40,759,0),vector(128,128,128),100);
		draw_line(vector(40,595,0),vector(128,128,128),100);
		draw_line(vector(40,595,0),NULL,0);
		
		//Raster:
		//vertikae Line
		draw_line(vector(40,677,0),NULL,0);
		draw_line(vector(40,677,0),vector(128,128,128),100);
		draw_line(vector(860,677,0),vector(128,128,128),100);
		draw_line(vector(860,677,0),NULL,0);
		//horizontale Lines
		draw_line(vector(122,595,0),NULL,0);
		draw_line(vector(122,595,0),vector(128,128,128),100);
		draw_line(vector(122,759,0),vector(128,128,128),100);
		draw_line(vector(122,759,0),NULL,0);
		
		draw_line(vector(204,595,0),NULL,0);
		draw_line(vector(204,595,0),vector(128,128,128),100);
		draw_line(vector(204,759,0),vector(128,128,128),100);
		draw_line(vector(204,759,0),NULL,0);
	
		draw_line(vector(286,595,0),NULL,0);
		draw_line(vector(286,595,0),vector(128,128,128),100);
		draw_line(vector(286,759,0),vector(128,128,128),100);
		draw_line(vector(286,759,0),NULL,0);
		
		draw_line(vector(368,595,0),NULL,0);
		draw_line(vector(368,595,0),vector(128,128,128),100);
		draw_line(vector(368,759,0),vector(128,128,128),100);
		draw_line(vector(368,759,0),NULL,0);
		
		draw_line(vector(450,595,0),NULL,0);
		draw_line(vector(450,595,0),vector(128,128,128),100);
		draw_line(vector(450,759,0),vector(128,128,128),100);
		draw_line(vector(450,759,0),NULL,0);
		
		draw_line(vector(532,595,0),NULL,0);
		draw_line(vector(532,595,0),vector(128,128,128),100);
		draw_line(vector(532,759,0),vector(128,128,128),100);
		draw_line(vector(532,759,0),NULL,0);
		
		draw_line(vector(614,595,0),NULL,0);
		draw_line(vector(614,595,0),vector(128,128,128),100);
		draw_line(vector(614,759,0),vector(128,128,128),100);
		draw_line(vector(614,759,0),NULL,0);
		
		draw_line(vector(614,595,0),NULL,0);
		draw_line(vector(614,595,0),vector(128,128,128),100);
		draw_line(vector(614,759,0),vector(128,128,128),100);
		draw_line(vector(614,759,0),NULL,0);	
		
		draw_line(vector(696,595,0),NULL,0);
		draw_line(vector(696,595,0),vector(128,128,128),100);
		draw_line(vector(696,759,0),vector(128,128,128),100);
		draw_line(vector(696,759,0),NULL,0);
		
		draw_line(vector(778,595,0),NULL,0);
		draw_line(vector(778,595,0),vector(128,128,128),100);
		draw_line(vector(778,759,0),vector(128,128,128),100);
		draw_line(vector(778,759,0),NULL,0);

		wait(1);
	}
}